var ToodledoVars = window.arguments[0];
var ToodledoFolders = window.arguments[1]; //will load folders/contexts/goals and Pro status once each time plugin loads
var ToodledoFolderIds = window.arguments[2];
var ToodledoContexts = window.arguments[3];
var ToodledoContextIds = window.arguments[4];
var ToodledoGoals = window.arguments[5];
var ToodledoGoalIds = window.arguments[6];
var ToodledoLocations = window.arguments[7];
var ToodledoLocationIds = window.arguments[8];
var ToodledoloadedFolders = 0;
var ToodledoloadedContexts = 0;
var ToodledoloadedGoals = 0;
var ToodledoloadedLocations = 0;

//callback when ajax completes in this window
function Toodledo_UrlLoaded() {
	var res=XULToodledoChrome.httpRequest.responseText;
	var xml=XULToodledoChrome.httpRequest.responseXML;
	
	//Toodledo_Log("add.js: "+res);	

	if(xml.firstChild) {
		var root_node = xml.firstChild.tagName;
		
		if(root_node=="userid") {
		
			var userid = xml.firstChild.textContent;
			if(userid==0) {
				Toodledo_AddError();
			} else if(userid==1) {
				Toodledo_AddError();
			} else {
				XULToodledoChrome.branch.setCharPref("toodledopref_userid", userid);
				ToodledoGetAPIKey(); //once we get a userid, try to get a key
			}
			
		} else if(root_node=="token") {
		
			var email = XULToodledoChrome.branch.getCharPref("toodledopref_email");
			var token = xml.firstChild.textContent;
			var password = Toodledo_GetPassword(email);
			var userid = XULToodledoChrome.branch.getCharPref("toodledopref_userid");
			
			ToodledoVars.key = ToodledoMD5(ToodledoMD5(password)+token+userid);

			Toodledo_AddLoad();	
			
		} else if(root_node=="folders") {
		
			var folders = xml.firstChild;
			
			if(folders.childNodes.length==0) {
				ToodledoFolders[0] = "None";
				ToodledoFolderIds[i] = "0";
			} else { 
				var j=0;
				for(var i=0;i<folders.childNodes.length;i++) {
					if(folders.childNodes[i].attributes[2].value==0) { //hide archived folders
						ToodledoFolders[j] = folders.childNodes[i].textContent;
						ToodledoFolderIds[j] = folders.childNodes[i].attributes[0].value;
						j++;
					}
				}
			}
			if(XULToodledoChrome.timeoutID!=0) clearTimeout(XULToodledoChrome.timeoutID);
			Toodledo_AddLoad();	
			
		} else if(root_node=="contexts") {
			
			var contexts = xml.firstChild;
			
			if(contexts.childNodes.length==0) {
				ToodledoContexts[0] = "None";
				ToodledoContextIds[i] = "0";
			} else { 
				for(var i=0;i<contexts.childNodes.length;i++) {
					ToodledoContexts[i] = contexts.childNodes[i].textContent;
					ToodledoContextIds[i] = contexts.childNodes[i].attributes[0].value;
					//if(contexts.childNodes[i].attributes[1].value==1) ToodledoContextIds[999] = contexts.childNodes[i].attributes[0].value;//default
				}
			}
			if(XULToodledoChrome.timeoutID!=0) clearTimeout(XULToodledoChrome.timeoutID);
			Toodledo_AddLoad();	
			
		} else if(root_node=="goals") {

			var goals = xml.firstChild;
			
			if(goals.childNodes.length==0) {
				ToodledoGoals[0] = "None";
				ToodledoGoalIds[i] = "0";
			} else { 
				var j = 0;
				for(var i=0;i<goals.childNodes.length;i++) {
					if(goals.childNodes[i].attributes[3].value==0) { //hide archived folders
						ToodledoGoals[j] = goals.childNodes[i].textContent;
						ToodledoGoalIds[j] = goals.childNodes[i].attributes[0].value;
						
						if(goals.childNodes[i].attributes[1].value==0) ToodledoGoals[j] += " (Lifelong)";
						else if(goals.childNodes[i].attributes[1].value==1) ToodledoGoals[j] += " (Long-term)";
						else if(goals.childNodes[i].attributes[1].value==2) ToodledoGoals[j] += " (Short-term)";
							
						j++;
					}
				}
			}
			if(XULToodledoChrome.timeoutID!=0) clearTimeout(XULToodledoChrome.timeoutID);
			Toodledo_AddLoad();	
			
		} else if(root_node=="locations") {
			
			var locations = xml.firstChild;
			
			if(locations.childNodes.length==0) {
				ToodledoLocations[0] = "None";
				ToodledoLocationIds[i] = "0";
			} else { 
				for(var i=0;i<locations.childNodes.length;i++) {
					ToodledoLocations[i] = locations.childNodes[i].textContent;
					ToodledoLocationIds[i] = locations.childNodes[i].attributes[0].value;
					//if(contexts.childNodes[i].attributes[1].value==1) ToodledoContextIds[999] = contexts.childNodes[i].attributes[0].value;//default
				}
			}
			if(XULToodledoChrome.timeoutID!=0) clearTimeout(XULToodledoChrome.timeoutID);
			Toodledo_AddLoad();	
			
		} else if(root_node=="account") {
			
			var account = xml.firstChild;
			
			for(var i=0;i<account.childNodes.length;i++) {
				if(account.childNodes[i].tagName=="pro" && account.childNodes[i].textContent=="1") XULToodledoChrome.branch.setBoolPref("toodledopref_pro", true);
				else if(account.childNodes[i].tagName=="pro") XULToodledoChrome.branch.setBoolPref("toodledopref_pro", false);
			}
			XULToodledoChrome.branch.setBoolPref("toodledopref_proLoaded", true);
			
			if(XULToodledoChrome.timeoutID!=0) clearTimeout(XULToodledoChrome.timeoutID);
			Toodledo_AddLoad();	
		} else if(root_node=="error") { //TODO: if an error comes back, we can't add a task, so alter the dialog to display an error.
			
			var error_value = xml.firstChild.textContent;
			Toodledo_Log(error_value);	
					
			if(error_value=="key did not validate") { //perhaps the key expired. Try one more time
				if(XULToodledoChrome.TryOnce) {
					Toodledo_AddError();
					XULToodledoChrome.TryOnce=0;
				} else {
					ToodledoGetAPIKey(); 
					XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddLoad()",1000); //try again in 1 second
					XULToodledoChrome.TryOnce++;
				}
			} else if(error_value=="App blocked by user") {
				Toodledo_AddError();
			} else if(error_value=="invalid userid") {
				Toodledo_AddError();
			} else if(error_value=="no userid specified") {
				Toodledo_AddError();
			} 
			
		} else {
			Toodledo_Log("Unknown response from toodledo.com");	
		}
	
	}
}

function Toodledo_AddError() {
	document.getElementById("add.task.caption").label = "Error";
	document.getElementById("add.task.form").hidden = true;
	document.getElementById("add.task.error").hidden = false;
	XULToodledoChrome.branch.setCharPref("toodledopref_userid", ""); //userid is not valid anymore
	Toodledo_setPassword("");
	if(XULToodledoChrome.timeoutID!=0) clearTimeout(XULToodledoChrome.timeoutID);			
}

function Toodledo_enableAdvancedRep() {
	if(document.getElementById("toodledo.add.repeat").value==50) {
		document.getElementById("toodledo.add.repA").disabled=false;
	} else {
		document.getElementById("toodledo.add.repA").disabled=true;
		document.getElementById("toodledo.add.repA").value="";
	}
}

//Called when the add form is loaded, or when group data has been returned and we need to reload
function Toodledo_AddLoad() {
	ToodledoVars.url = null;

	if(XULToodledoChrome.timeoutID!=0) clearTimeout(XULToodledoChrome.timeoutID); //if there is a timeout, clear it
	
	if(ToodledoVars.selectedText) {
		if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check5")) document.getElementById("toodledo.add.title").value =  ToodledoVars.selectedText;
		else document.getElementById("toodledo.add.note").value =  ToodledoVars.selectedText;
	}
	document.getElementById("Toodledoadd1").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check1"); 
	document.getElementById("Toodledoadd2").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check2");
	document.getElementById("Toodledoadd3").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check3");
	document.getElementById("Toodledoadd4").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check4");
	document.getElementById("Toodledoadd5").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check5");
	document.getElementById("Toodledoadd6").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check6");
	document.getElementById("Toodledoadd7").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check7");
	document.getElementById("Toodledoadd8").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check8");
	document.getElementById("Toodledoadd9").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check9");
	document.getElementById("Toodledoadd10").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check10"); //due time
	document.getElementById("Toodledoadd11").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check11");
	document.getElementById("Toodledoadd12").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check12");
	document.getElementById("Toodledoadd13").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check13");
	document.getElementById("Toodledoadd14").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check14");
	
	if(XULToodledoChrome.branch.getBoolPref("toodledopref_pro")) { //reminder
		document.getElementById("Toodledoadd15").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check2");
		document.getElementById("toodledo.add.reminder1").hidden = !XULToodledoChrome.branch.getBoolPref("toodledopref_check10");
		document.getElementById("toodledo.add.reminder2").hidden = XULToodledoChrome.branch.getBoolPref("toodledopref_check10");
		document.getElementById("toodledo.add.reminder3").hidden = true;
	} else {
		document.getElementById("toodledo.add.reminder1").hidden = true;
		document.getElementById("toodledo.add.reminder2").hidden = true;
		document.getElementById("toodledo.add.reminder3").hidden = false;
	}
													
	if(!ToodledoVars.key) { //need key to continue
		if(XULToodledoChrome.TryOnce) {
			XULToodledoChrome.TryOnce=0;
		} else {
			ToodledoGetAPIKey();
			XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddLoad()",4000); //try again in 4 second
			XULToodledoChrome.TryOnce++;
		}
		
		return;
	} 

	if(XULToodledoChrome.branch.getBoolPref("toodledopref_check2") && !XULToodledoChrome.branch.getBoolPref("toodledopref_proLoaded")) { //get pro status for reminders
		if(ToodledoVars.key) {
			Toodledo_GetUrl(";method=getAccountInfo",true,ToodledoVars.key);
		}
		if(XULToodledoChrome.TryOnce) {
			XULToodledoChrome.TryOnce=0;
		} else {
			if(XULToodledoChrome.timeoutID==0) XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddLoad()",5000); //try again in 5 seconds
			XULToodledoChrome.TryOnce++;
		}
		
		return;
	}
	
	if(XULToodledoChrome.branch.getBoolPref("toodledopref_check1")) {  //refresh folder list
		if(ToodledoFolders.length>0) { //if the folders are loaded
			var menu = document.getElementById("toodledo.add.folders");
			
			if(ToodledoloadedFolders==0) { //if the menu isnt yet constructed
				for(var i=0;i<ToodledoFolders.length;i++) { //construct the menu
					menu.appendItem(ToodledoFolders[i],ToodledoFolderIds[i]);
				}
				ToodledoloadedFolders = 1;
			}
		} else { //try to load the folders array
			if(ToodledoVars.key) {
				Toodledo_GetUrl(";method=getFolders",true,ToodledoVars.key);
			}
			if(XULToodledoChrome.TryOnce) {
				XULToodledoChrome.TryOnce=0;
			} else {
				if(XULToodledoChrome.timeoutID==0) XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddLoad()",5000); //try again in 5 seconds
				XULToodledoChrome.TryOnce++;
			}
			return;
		}
	}
	
	if(XULToodledoChrome.branch.getBoolPref("toodledopref_check8")) {  //refresh context list
		
		if(ToodledoContexts.length>0) { //if the context are loaded and the menu isnt			
			var menu = document.getElementById("toodledo.add.contexts");
			
			if(ToodledoloadedContexts==0) { //if the menu isnt yet constructed
				var added=null;
				for(var i=0;i<ToodledoContexts.length;i++) { //construct the menu
					added = menu.appendItem(ToodledoContexts[i],ToodledoContextIds[i]);
					//if(ToodledoContextIds[i]==ToodledoContextIds[999]) menu.selectedItem = added;//set default
				}
				ToodledoloadedContexts = 1;
			}
		} else { //try to load the context array
			if(ToodledoVars.key) {
				Toodledo_GetUrl(";method=getContexts",true,ToodledoVars.key);
			}
			if(XULToodledoChrome.TryOnce) {
				XULToodledoChrome.TryOnce=0;
			} else {
				if(XULToodledoChrome.timeoutID==0) XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddLoad()",5200); //try again in 5.2 seconds
				XULToodledoChrome.TryOnce++;
			}
			return;
		}
	}
	
	if(XULToodledoChrome.branch.getBoolPref("toodledopref_check9")) {  //refresh goal list
		
		if(ToodledoGoals.length>0) { //if the goals are loaded and the menu isnt			
			var menu = document.getElementById("toodledo.add.goal");
			
			if(ToodledoloadedGoals==0) { //if the menu isnt yet constructed
				var added=null;
				for(var i=0;i<ToodledoGoals.length;i++) { //construct the menu
					added = menu.appendItem(ToodledoGoals[i],ToodledoGoalIds[i]);
				}
				ToodledoloadedGoals = 1;
			}
		} else { //try to load the context array
			if(ToodledoVars.key) {
				Toodledo_GetUrl(";method=getGoals",true,ToodledoVars.key);
			}
			if(XULToodledoChrome.TryOnce) {
				XULToodledoChrome.TryOnce=0;
			} else {
				if(XULToodledoChrome.timeoutID==0) XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddLoad()",5200); //try again in 5.2 seconds
				XULToodledoChrome.TryOnce++;
			}
			return;
		}
	}
	
	if(XULToodledoChrome.branch.getBoolPref("toodledopref_check15")) {  //refresh location list
		
		if(ToodledoLocations.length>0) { //if the goals are loaded and the menu isnt			
			var menu = document.getElementById("toodledo.add.location");
			
			if(ToodledoloadedLocations==0) { //if the menu isnt yet constructed
				var added=null;
				for(var i=0;i<ToodledoLocations.length;i++) { //construct the menu
					added = menu.appendItem(ToodledoLocations[i],ToodledoLocationIds[i]);
				}
				ToodledoloadedLocations = 1;
			}
		} else { //try to load the context array
			if(ToodledoVars.key) {
				Toodledo_GetUrl(";method=getLocations",true,ToodledoVars.key);
			}
			if(XULToodledoChrome.TryOnce) {
				XULToodledoChrome.TryOnce=0;
			} else {
				if(XULToodledoChrome.timeoutID==0) XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddLoad()",5200); //try again in 5.2 seconds
				XULToodledoChrome.TryOnce++;
			}
			return;
		}
	}
}

//This is called when the dialog is OKed. It stuffs everything into a variable.  The calling function Toodledo.js will do the Ajax.
function Toodledo_AddTask() {

	var title = document.getElementById("toodledo.add.title").value;
	var folder = document.getElementById("toodledo.add.folders").value;
	var startdate = document.getElementById("toodledo.add.startdate").value;
	var duedate = document.getElementById("toodledo.add.duedate").value;
	var repeat = document.getElementById("toodledo.add.repeat").value;
	var repeatA = document.getElementById("toodledo.add.repA").value;
	var length = ToodledoTimeToMins(document.getElementById("toodledo.add.length").value);
	var priority = document.getElementById("toodledo.add.priority").value;
	var tag = document.getElementById("toodledo.add.tag").value;
	var context = document.getElementById("toodledo.add.contexts").value;
	var goal = document.getElementById("toodledo.add.goal").value;
	var location = document.getElementById("toodledo.add.location").value;
	var duetime = document.getElementById("toodledo.add.duetime");
	var starttime = document.getElementById("toodledo.add.starttime");
	var note = document.getElementById("toodledo.add.note").value;
	var dateP = document.getElementById("toodledo.add.dateP").value;
	var timeP = document.getElementById("toodledo.add.timeP").value;
	var stimeP = document.getElementById("toodledo.add.stimeP").value;
	var startP = document.getElementById("toodledo.add.startP").value;
	var status = document.getElementById("toodledo.add.status").value;
	var star = document.getElementById("toodledo.add.star").value;
	var reminder = 0;
	
	if(XULToodledoChrome.branch.getBoolPref("toodledopref_pro")) { //reminder
		if(XULToodledoChrome.branch.getBoolPref("toodledopref_check10")) reminder = document.getElementById("toodledo.add.reminder1").value;
		else reminder = document.getElementById("toodledo.add.reminder2").value;
	} else {
		reminder = document.getElementById("toodledo.add.reminder3").value;
	}
			
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check1")) folder="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check2")) duedate="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check3")) repeat="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check4")) length="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check5")) note="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check6")) priority="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check7")) tag="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check8")) context="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check9")) goal="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check10")) duetime="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check11")) startdate="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check12")) status="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check13")) starttime="";
	if(!XULToodledoChrome.branch.getBoolPref("toodledopref_check14")) star="";
	
	title = title.replace(/%/g,"%25");
	title = title.replace(/&/g,"%26");
	title = title.replace(/;/g,"%3B");
	title = title.replace(/\+/g,"%2B");
	title = title.replace(/#/g,"%23");
	if(title=="") title="New Task added without a title";
	
	tag = tag.replace(/%/g,"%25");
	tag = tag.replace(/&/g,"%26");
	tag = tag.replace(/;/g,"%3B");
	tag = tag.replace(/\+/g,"%2B");
	tag = tag.replace(/#/g,"%23");
	
	//note = note.replace(/%/g,"%25");
	//note = note.replace(/&/g,"%26");
	//note = note.replace(/;/g,"%3B");
	//note = note.replace(/\+/g,"%2B");
	//note = note.replace(/#/g,"%23");
	note = encodeURIComponent(note); //this works better
	
	repeatA = repeatA.replace(/%/g,"");
	repeatA = repeatA.replace(/&/g,"");
	repeatA = repeatA.replace(/;/g,"");
	repeatA = repeatA.replace(/\+/g,"");
	repeatA = repeatA.replace(/#/g,"");
		
	var hour = duetime.hour;
	var append = "am";
	if(duetime.isPM) { hour -= 12; append="pm"; }
	duetime = hour+":"+duetime.minute+" "+append;
	
	hour = starttime.hour;
	append = "am";
	if(starttime.isPM) { hour -= 12; append="pm"; }
	starttime = hour+":"+starttime.minute+" "+append;
	
	if(dateP==1) duedate="";
	if(startP==1) startdate="";
	if(timeP==1) duetime="";
	if(stimeP==1) starttime="";
		
	var url = ";method=addTask;title="+title+";folder="+folder+";location="+location+";startdate="+startdate+";duedate="+duedate+";status="+status+";repeat="+repeat+";rep_advanced="+repeatA+";length="+length+";priority="+priority+";tag="+tag+";context="+context+";goal="+goal+";duetime="+duetime+";starttime="+starttime+";star="+star+";reminder="+reminder+";note="+note;
	
	
	if(title) ToodledoVars.url = url;
}
