var ToodledoVars;

function Toodledo_LoadOptions() {
	if(window.arguments) ToodledoVars = window.arguments[0];
	
	var email = XULToodledoChrome.branch.getCharPref("toodledopref_email");
	
	document.getElementById("Toodledo-email").value = email;
	document.getElementById("Toodledo-1").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check1");
	document.getElementById("Toodledo-2").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check2");
	document.getElementById("Toodledo-3").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check3");
	document.getElementById("Toodledo-4").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check4");
	document.getElementById("Toodledo-5").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check5");
	document.getElementById("Toodledo-6").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check6");
	document.getElementById("Toodledo-7").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check7");
	document.getElementById("Toodledo-8").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check8");
	document.getElementById("Toodledo-9").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check9");
	document.getElementById("Toodledo-10").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check10");
	document.getElementById("Toodledo-11").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check11");
	document.getElementById("Toodledo-12").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check12");
	document.getElementById("Toodledo-13").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check13");
	document.getElementById("Toodledo-14").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check14");
	document.getElementById("Toodledo-15").checked = XULToodledoChrome.branch.getBoolPref("toodledopref_check15");
	//When adding a new one, don't forget to add the default to the defaults/toodledo.js folder.
	
	var password = Toodledo_GetPassword(email);
	
	document.getElementById("Toodledo-pass").value = password;
}


function Toodledo_SaveOptions() {
	var email = document.getElementById("Toodledo-email").value;
	var pass = document.getElementById("Toodledo-pass").value;
	
	if(ToodledoVars) ToodledoVars.key = null; //key is invalidated so that authentication is attempted again
	XULToodledoChrome.branch.setCharPref("toodledopref_email", email);
	XULToodledoChrome.branch.setCharPref("toodledopref_userid", ""); //when the email/password change we need to refresh the userid
	XULToodledoChrome.branch.setBoolPref("toodledopref_check1", document.getElementById("Toodledo-1").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check2", document.getElementById("Toodledo-2").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check3", document.getElementById("Toodledo-3").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check4", document.getElementById("Toodledo-4").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check5", document.getElementById("Toodledo-5").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check6", document.getElementById("Toodledo-6").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check7", document.getElementById("Toodledo-7").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check8", document.getElementById("Toodledo-8").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check9", document.getElementById("Toodledo-9").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check10", document.getElementById("Toodledo-10").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check11", document.getElementById("Toodledo-11").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check12", document.getElementById("Toodledo-12").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check13", document.getElementById("Toodledo-13").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check14", document.getElementById("Toodledo-14").checked);
	XULToodledoChrome.branch.setBoolPref("toodledopref_check15", document.getElementById("Toodledo-15").checked);
		
	Toodledo_setPassword(pass);

	if(email && pass) {
		email = email.replace(/&/g,"%26");
		email = email.replace(/;/g,"%3B");
		email = email.replace(/\+/g,"%2B");
		email = email.replace(/%/g,"%25");
		email = email.replace(/\?/g,"%3F");
		email = email.replace(/#/g,"%23");
		email = email.replace(/=/g,"%3D");
		pass = pass.replace(/%/g,"%25");
		pass = pass.replace(/&/g,"%26");
		pass = pass.replace(/;/g,"%3B");
		pass = pass.replace(/\+/g,"%2B");
		pass = pass.replace(/\?/g,"%3F");
		pass = pass.replace(/#/g,"%23");
		pass = pass.replace(/=/g,"%3D");
	
		Toodledo_GetUrl(";method=getUserid;email="+email+";pass="+pass,false,"");
	} else {
		return true;
	}
	
	return false;
}

function Toodledo_UrlLoaded() {
	var res=XULToodledoChrome.httpRequest.responseText;
	var xml=XULToodledoChrome.httpRequest.responseXML;
	
	//Toodledo_Log(res);	

	if(xml.firstChild) {
		var root_node = xml.firstChild.tagName;
		
		if(root_node=="userid") {
		
			var userid = xml.firstChild.textContent;
			if(userid==0) {
				document.getElementById("toodledo.options.error").hidden = false;
			} else if(userid==1) {
				document.getElementById("toodledo.options.error").hidden = false;
			} else {
				XULToodledoChrome.branch.setCharPref("toodledopref_userid", userid);
				window.close();
			}
			
		} else if(root_node=="error") {
			var error_value = xml.firstChild.textContent;
			
			if(error_value=="key did not validate") {  //perhaps the key expired. Try one more time
				if(XULToodledoChrome.TryOnce) {
					document.getElementById("toodledo.options.error").hidden = false;
					XULToodledoChrome.TryOnce=0;
				} else {
					ToodledoGetAPIKey();
					XULToodledoChrome.TryOnce++;
				}
			} else if(error_value=="App blocked by user") {
				document.getElementById("toodledo.options.error").hidden = false;
				XULToodledoChrome.branch.setCharPref("toodledopref_userid", ""); //userid is not valid anymore
				Toodledo_setPassword("");
			}
			
		} else {
			Toodledo_Log("Unknown response from toodledo.com");	
		}
	
	}
}